'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _createChainedFunction = require('./utils/createChainedFunction');

var _createChainedFunction2 = _interopRequireDefault(_createChainedFunction);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Checkbox = _react2.default.createClass({
    displayName: 'Checkbox',

    propTypes: {
        id: _react2.default.PropTypes.string,
        name: _react2.default.PropTypes.string,
        inline: _react2.default.PropTypes.bool,
        title: _react2.default.PropTypes.string,
        disabled: _react2.default.PropTypes.bool,
        checked: _react2.default.PropTypes.bool,
        onClick: _react2.default.PropTypes.func,
        onChange: _react2.default.PropTypes.func
    },
    contextTypes: {
        formGroup: _react2.default.PropTypes.object
    },
    getDefaultProps: function getDefaultProps() {
        return {
            inline: false,
            disabled: false
        };
    },
    getInitialState: function getInitialState() {
        return {
            checked: this.props.checked
        };
    },
    handleChange: function handleChange(event) {
        if (this.props.disabled) {
            return;
        }

        this.setState({
            checked: !this.state.checked
        });
    },
    render: function render() {
        var _props = this.props;
        var type = _props.type;
        var inline = _props.inline;
        var title = _props.title;
        var name = _props.name;
        var disabled = _props.disabled;
        var className = _props.className;
        var children = _props.children;
        var onChange = _props.onChange;

        var props = _objectWithoutProperties(_props, ['type', 'inline', 'title', 'name', 'disabled', 'className', 'children', 'onChange']);

        var classes = (0, _classnames2.default)({
            'checkbox-inline': inline
        }, className);

        var checkboxClasses = (0, _classnames2.default)({
            'checker': true,
            'disabled': disabled
        });

        var input = _react2.default.createElement(
            'span',
            { className: (0, _classnames2.default)({
                    'checked': this.state.checked
                }) },
            _react2.default.createElement('input', {
                type: 'checkbox',
                name: name,
                disabled: disabled,
                onChange: (0, _createChainedFunction2.default)(this.handleChange, onChange),
                defaultChecked: this.state.checked
            })
        );

        return _react2.default.createElement(
            'label',
            { className: classes },
            _react2.default.createElement(
                'div',
                {
                    className: checkboxClasses,
                    role: 'checkbox'
                },
                input
            ),
            title || children
        );
    }
});

exports.default = Checkbox;