'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Checkbox = require('./Checkbox');

var _Checkbox2 = _interopRequireDefault(_Checkbox);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CheckboxList = _react2.default.createClass({
    displayName: 'CheckboxList',

    propTypes: {
        name: _react2.default.PropTypes.string,
        inline: _react2.default.PropTypes.bool
    },
    render: function render() {
        var _props = this.props;
        var className = _props.className;
        var inline = _props.inline;
        var name = _props.name;
        var children = _props.children;


        var clesses = (0, _classnames2.default)({
            'checkbox-list': true
        }, className);

        var items = _react2.default.Children.map(children, function (child, index) {
            return _react2.default.cloneElement(child, {
                key: index,
                ref: 'checkbox_' + index,
                inline: inline,
                name: name
            }, child.props.children);
        });

        return _react2.default.createElement(
            'div',
            {
                className: clesses,
                role: 'checkbox-list'
            },
            items
        );
    }
});

exports.default = CheckboxList;