'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var FormGroup = _react2.default.createClass({
    displayName: 'FormGroup',

    propTypes: {
        controlId: _react2.default.PropTypes.string,
        validationState: _react2.default.PropTypes.oneOf(['success', 'warning', 'error'])
    },
    childContextTypes: {
        formGroup: _react2.default.PropTypes.object.isRequired
    },
    getChildContext: function getChildContext() {
        var _props = this.props;
        var controlId = _props.controlId;
        var validationState = _props.validationState;
        var children = _props.children;

        return {
            formGroup: {
                controlId: controlId,
                validationState: validationState
            }
        };
    },
    render: function render() {
        var _props2 = this.props;
        var validationState = _props2.validationState;
        var className = _props2.className;
        var children = _props2.children;
        var controlId = _props2.controlId;

        var props = _objectWithoutProperties(_props2, ['validationState', 'className', 'children', 'controlId']);

        var classes = (0, _classnames2.default)(_defineProperty({
            'form-group': true
        }, 'has-' + validationState, validationState && true), className);

        return _react2.default.createElement(
            'div',
            _extends({}, props, { className: classes }),
            children
        );
    }
});

exports.default = FormGroup;